Bug 732986 - thp: fix tail page refcounting
Summary: thp: fix tail page refcounting
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: kernel
Version: 6.2
Hardware: x86_64
OS: Linux
low
medium
Target Milestone: rc
: ---
Assignee: Andrea Arcangeli
QA Contact: Caspar Zhang
URL:
Whiteboard:
Depends On:
Blocks: 743047 746528
TreeView+ depends on / blocked
 
Reported: 2011-08-24 11:43 UTC by Andrea Arcangeli
Modified: 2015-07-06 02:43 UTC (History)
3 users (show)

Fixed In Version: kernel-2.6.32-196.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 746528 (view as bug list)
Environment:
Last Closed: 2011-12-06 14:06:28 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:1530 normal SHIPPED_LIVE Moderate: Red Hat Enterprise Linux 6 kernel security, bug fix and enhancement update 2011-12-06 01:45:35 UTC

Description Andrea Arcangeli 2011-08-24 11:43:33 UTC
Description of problem: Fix tail page accounting for some theoretical SMP race condition


Version-Release number of selected component (if applicable): 6.0,6.1,6.2


How reproducible: Not reproducible, only theoretical so far. I may try to write a specific testcase to try to reproduce it, but it's very unlikely any real life applications is capable of triggering this. It was found purely by code review while developing new VM features (working set estimation code on linux-mm).


Steps to Reproduce:
1.
2.
3.
  
Actual results: the page_count(head_page) may go off by one with speculative cache reads or during heavy O_DIRECT workloads in presence of a flood of split_huge_page (not common scenario and still split_huge_page would need to run within two assembly instruction, the race window is 1 asm insn, so incredibly small with a million of pages potentially under swap and such a small race window of 1 asm insn)


Expected results: correct page_count(head_page) at all times

Comment 3 RHEL Product and Program Management 2011-08-28 08:49:45 UTC
This request was evaluated by Red Hat Product Management for inclusion
in a Red Hat Enterprise Linux maintenance release. Product Management has 
requested further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed 
products. This request is not yet committed for inclusion in an Update release.

Comment 4 Andrea Arcangeli 2011-08-28 17:16:50 UTC
Updated patch posted to rhkernel-list with Message-ID: <20110828165559.GB4051@redhat.com>

New build here:

http://brewweb.devel.redhat.com/brew/taskinfo?taskID=3587311

Comment 6 Aristeu Rozanski 2011-09-12 15:03:48 UTC
Patch(es) available on kernel-2.6.32-196.el6

Comment 15 errata-xmlrpc 2011-12-06 14:06:28 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2011-1530.html


Note You need to log in before you can comment on or make changes to this bug.